package com.sun.org.apache.xpath.internal.functions;

import javax.xml.transform.TransformerException;
import com.sun.org.apache.xml.internal.dtm.DTMIterator;
import com.sun.org.apache.xpath.internal.objects.XNodeSet;
import com.sun.org.apache.xpath.internal.objects.XObject;
import com.sun.org.apache.xml.internal.dtm.DTM;
import java.util.StringTokenizer;
import com.sun.org.apache.xpath.internal.NodeSetDTM;
import com.sun.org.apache.xml.internal.utils.StringVector;
import com.sun.org.apache.xpath.internal.XPathContext;

public class FuncId extends FunctionOneArg
{
    static final long serialVersionUID = 8930573966143567310L;
    
    public FuncId() {
    }
    
    private StringVector getNodesByID(XPathContext xctxt, int docContext, String refval, StringVector usedrefs, NodeSetDTM nodeSet, boolean mayBeMore) {
        if (null != refval) {
            String ref = null;
            StringTokenizer tokenizer = new StringTokenizer(refval);
            boolean hasMore = tokenizer.hasMoreTokens();
            DTM dtm = xctxt.getDTM(docContext);
            while (hasMore) {
                ref = tokenizer.nextToken();
                hasMore = tokenizer.hasMoreTokens();
                if (null != usedrefs && usedrefs.contains(ref)) {
                    ref = null;
                }
                else {
                    int node = dtm.getElementById(ref);
                    if (-1 != node) {
                        nodeSet.addNodeInDocOrder(node, xctxt);
                    }
                    if (null != ref && (hasMore || mayBeMore)) {
                        if (null == usedrefs) {
                            usedrefs = new StringVector();
                        }
                        usedrefs.addElement(ref);
                    }
                    else {
                        continue;
                    }
                }
            }
            return usedrefs;
        }
        return usedrefs;
    }
    
    @Override
    public XObject execute(XPathContext xctxt) throws TransformerException {
        int context = xctxt.getCurrentNode();
        DTM dtm = xctxt.getDTM(context);
        int docContext = dtm.getDocument();
        if (-1 == docContext) {
            this.error(xctxt, "ER_CONTEXT_HAS_NO_OWNERDOC", (Object[])null);
        }
        XObject arg = this.m_arg0.execute(xctxt);
        int argType = arg.getType();
        XNodeSet nodes = new XNodeSet(xctxt.getDTMManager());
        NodeSetDTM nodeSet = nodes.mutableNodeset();
        if (4 == argType) {
            DTMIterator ni = arg.iter();
            StringVector usedrefs = null;
            String refval2;
            for (int pos = ni.nextNode(); -1 != pos; pos = ni.nextNode(), usedrefs = this.getNodesByID(xctxt, docContext, refval2, usedrefs, nodeSet, -1 != pos)) {
                DTM ndtm = ni.getDTM(pos);
                refval2 = ndtm.getStringValue(pos).toString();
            }
        }
        else {
            if (-1 == argType) {
                return nodes;
            }
            String refval = arg.str();
            this.getNodesByID(xctxt, docContext, refval, null, nodeSet, false);
        }
        return nodes;
    }
}
